Car_Seat_Cover_Configurator-Laravel/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('privacy_policy', function () {
    return view('pages.privacy.privacy_policy');
});

Route::get('/view-my-configuration/{id}', 'Main\ViewConfigurationController@view');
Route::get('/view-my-em-configuration/{id}', 'Main\ViewConfigurationController@viewEmbroideryOrder');

Auth::routes();
Route::get('/unverified', 'HomeController@unverified')->name('unverified');

Route::middleware(['auth', 'verified'])->group(function () {
    Route::get('/import/brands', 'ImportController@import_brands');
    Route::get('/import/cars', 'ImportController@import_cars');
    Route::get('/view/cars', 'ImportController@view_cars');
    Route::get('/rename/duplicates', 'ImportController@rename_duplicates');
    Route::get('/remove/duplicates', 'ImportController@remove_duplicates');
    Route::get('/import/years_layouts', 'ImportController@import_years_layouts');
    Route::get('/import/trigger_brands', 'ImportController@trigger_brands');
    Route::get('/import/trigger_cars', 'ImportController@trigger_cars');
    Route::get('/import/trigger_years_layouts', 'ImportController@trigger_years_layouts');
    Route::get('/import/trigger_layout_images', 'ImportController@trigger_layout_images');
    Route::get('/home', 'HomeController@index')->name('home');
    Route::get('/passport', 'Api\ApiController@index')->name('api');
    Route::get('/orders', 'Main\OrderController@orders')->name('orders');
    Route::get('/orders/{id}', 'Main\OrderController@order');
    Route::get('/configurations', 'Main\ConfigurationController@configurations')->name('configurations');

    //uae
    Route::get('/view_all_layouts', 'Main\WellfitLayoutController@index');
    Route::get('/view_all_car_models', 'Main\WellfitLayoutController@carModels');

    Route::resource('users', 'Main\UserController');

    Route::match(['put', 'patch'], '/quick_car_model_edit','Main\WellfitLayoutController@updateCarModel');
    Route::match(['put', 'patch'], '/change_password/{id}','Main\UserController@change_password');


    Route::post('/logout_all', 'Main\UserController@logoutAll');


    Route::resource('manufacturers', 'Data\ManufacturerController');
    Route::resource('manufacturers.cars', 'Data\CarController');
    Route::resource('cars', 'Data\CarController');
    Route::resource('cars.models', 'Data\CarModelController');
    Route::resource('models', 'Data\CarModelController');
    Route::resource('models.seats', 'Data\SeatController');
    Route::resource('seats', 'Data\SeatController');
    Route::resource('models.layouts', 'Data\LayoutController');
    Route::resource('layouts', 'Data\LayoutController');
    Route::resource('layout_image', 'Data\LayoutImageController');
    Route::resource('layout_design', 'Data\LayoutDesignController');
    Route::resource('seats.configuration', 'Main\ConfigurationController');
    Route::resource('seats.base', 'Configuration\BaseController');
    Route::resource('seats.original_image', 'Configuration\OriginalImageController');
    Route::resource('seats.layer', 'Configuration\LayerController');
    Route::resource('layer', 'Configuration\LayerController');
    Route::resource('layer.variant', 'Configuration\VariantController');
    Route::resource('variant', 'Configuration\VariantController');
    Route::resource('materials', 'Data\MaterialController');
    Route::resource('colour_categories', 'Data\ColourCategoryController');
    Route::resource('companies', 'Data\CompanyController');
    Route::resource('colour_categories.colours', 'Data\ColourController');
    Route::resource('colours', 'Data\ColourController');
    Route::resource('gallery_categories', 'Data\GalleryCategoryController');
    Route::resource('gallery_categories.galleries', 'Data\GalleryController');
    Route::resource('galleries', 'Data\GalleryController');
    Route::resource('patterns', 'Data\PatternController');


    Route::post('/car_model_layouts', 'Data\GalleryController@carModelLayouts');
    Route::post('/car_brand_models', 'Data\GalleryController@carBrandModels');

    Route::get('/embroidery_orders', 'Main\OrderController@embroideryOrders')->name('embroidery_orders');
    Route::get('/embroidery_orders/{id}', 'Main\OrderController@embroideryOrder');



    Route::resource('seats.seat_photos', 'Data\SeatPhotoController');

    Route::resource('price_ranges', 'Data\PriceRangeController');

    Route::post('/models/{id}/seats/existing', 'Data\SeatController@storeExisting');

    Route::delete('/delete_seats/{id}/', 'Data\SeatController@deleteSeat');

    Route::match(['put', 'patch'], '/orders/update/{id}','Main\OrderController@update');
    Route::match(['put', 'patch'], '/embroidery_orders/update/{id}','Main\OrderController@updateEmbroidery');




    Route::get('/import_car_model_year', 'ImportController@import_car_model_year');
    Route::get('/import_seat_layout', 'ImportController@import_seat_layout');
    Route::get('/check_image_path', 'ImportController@check_image_path');
    Route::get('/check_image_path_order', 'ImportController@check_image_path_order');
    Route::get('/layout_price', 'ImportController@layout_price');




  // New Import UAE
Route::get('/trigger_brands', 'NewImportController@trigger_brands');
Route::get('/trigger_cars', 'NewImportController@trigger_cars');
Route::get('/trigger_car_models', 'NewImportController@trigger_car_models');
Route::get('/trigger_layouts', 'NewImportController@trigger_layouts');
Route::get('/trigger_layout_images', 'NewImportController@trigger_layout_images');
Route::get('/testing_query', 'NewImportController@testing_query');

});

Car_Seat_Cover_Configurator-Laravel/app/Models/Seat.php
<?php

namespace App\Models;
use Illuminate\Support\Facades\File;
use Storage;
use App;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Seat extends Model
{
    use SoftDeletes;
	protected $fillable = ['name','car_model_id','price_range_from','price_range_to'];

	public function car_model()
    {
        return $this->belongsTo('App\Models\CarModel');
    }

    public function car_models()
    {
       // return $this->belongsToMany('App\Models\CarModel');
        return $this->belongsToMany(CarModel::class, 'car_model_seats');
    }

	public function layers()
    {
        return $this->hasMany('App\Models\Layer');
    }

    public function seat_photos()
    {
        return $this->hasMany('App\Models\SeatPhoto');
    }

    public function price_ranges()
    {
        //  return $this->belongsToMany(Variant::class, 'price_range_variants');
        return $this->belongsToMany('App\Models\PriceRange', 'price_range_seats')->withPivot('seat_id');
    }
    public function getId()
	{
		return $this->id;
	}
    public function getName()
    {
    	return $this->name;
    }
    public function getImageURL()
    {
       return $this->image;
    }

    public function getBaseImageURL()
    {
       $file = 'storage/base/'.$this->getId().'.png';
        if (File::exists($file))
        {
            return 'base/'.$this->getId().'.png';
        }
        else return null;
    }
    public function getOriginalImageURL()
    {
       $file = 'storage/original_images/'.$this->getId().'.png';
        if (File::exists($file))
        {
            return 'original_images/'.$this->getId().'.png';
        }
        else return null;
    }
    
}

Car_Seat_Cover_Configurator-Laravel/app/Http/Controllers/Data/SeatController.php
<?php

namespace App\Http\Controllers\Data;

use App\Models\Car;
use App\Models\CarModelSeat;
use App\Models\Manufacturer;
use App\Models\PriceRange;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\CarModel;
use App\Models\Seat;
use Illuminate\Support\Facades\Input;
use Validator;

class SeatController extends Controller
{
    public function index($model_id)
    {
        if(!auth()->user()->hasRole('yaco_data_manager')) return view('pages.errors.no_permission');
        $car_model = CarModel::findOrFail($model_id);
        $tab = "models";
    	return view('pages.seats.partials.seats-list',compact('car_model','tab'));
    }

    public function create($model_id)
    {
        if(!auth()->user()->hasRole('yaco_data_manager')) return view('pages.errors.no_permission');
        $car_model = CarModel::findOrFail($model_id);
        $seats = Seat::where('car_model_id', '!=', 0)->where('car_model_id', env('COMMON_CAR_MODEL_ID'))->orderby('name', 'ASC')->get();
        $tab = "add-model";
        $price_ranges = PriceRange::orderby('id', 'DESC')->get();
        return view('pages.seats.partials.add-seat',compact('car_model','tab', 'seats', 'price_ranges'));
    }
    public function edit($id)
    {
        if(!auth()->user()->hasRole('yaco_data_manager')) return view('pages.errors.no_permission');
       $seat = Seat::findOrFail($id);
       $car_model = CarModel::findOrFail($seat->car_model_id);

        $price_ranges = PriceRange::orderby('id', 'DESC')->get();
        $assignedRanges  = $seat->price_ranges->pluck('id')->toArray();

        return view('pages.seats.partials.edit-seat',compact('car_model','seat', 'price_ranges', 'assignedRanges'));
    }
    public function store(Request $request, $car_model_id)
    {

        if(env('EMBROIDERY_CAR_MODEL_ID')==$car_model_id)
        {
            Validator::make($request->all(), [
                'name' => 'required',
                'image' => 'required|mimes:jpeg,bmp,png',
                'extra_price' => 'required',
                'price_range' => 'required|min:1',
            ])->validate();
        }
        else
        {
            Validator::make($request->all(), [
                'name' => 'required',
                'extra_price' => 'required',
                'image' => 'required|mimes:jpeg,bmp,png',
            ])->validate();
        }
		$path = $request->file('image')->store('public/seats');

        $seat = new Seat();
        $seat->name = $request->name;
        $seat->extra_price = $request->extra_price;
        $seat->car_model_id = $car_model_id;
        $seat->image = str_replace("public/","",$path);
        $seat->save();


        if(env('EMBROIDERY_CAR_MODEL_ID')==$car_model_id)
        {
            $seat->price_ranges()->attach($request->price_range);

        }

        $car_model_seat = new CarModelSeat();
        $car_model_seat->seat_id = $seat->id;
        $car_model_seat->car_model_id = $car_model_id;

        $car_model_seat->save();




        return back()->with('status', 'Seat Added!');
    }


    public function storeExisting(Request $request, $car_model_id)
    {
        Validator::make($request->all(), [
            'seat_id' => 'required|unique:car_model_seats,seat_id,null,null,car_model_id,'.$car_model_id,

        ])->validate();


        $car_model_seat = new CarModelSeat();
        $car_model_seat->seat_id = $request->seat_id;
        $car_model_seat->car_model_id = $car_model_id;

        $car_model_seat->save();

        return back()->with('status', 'Seat Added!');
    }



    public function update(Request $request, $id)
    {
        $seat = Seat::find($id);
        if(env('EMBROIDERY_CAR_MODEL_ID')==$seat->car_model_id) {

            Validator::make(Input::all(), [
                'name' => 'required',
                'price_range' => 'required|min:1',
                'extra_price' => 'required',
                'image' => 'mimes:jpeg,bmp,png',
            ])->validate();
        }
        else
            {
                Validator::make(Input::all(), [
                    'name' => 'required',
                    'extra_price' => 'required',
                    'image' => 'mimes:jpeg,bmp,png',
                ])->validate();
        }

        if(Input::file('image')) $path = Input::file('image')->store('public/seats');

        $seat->name = Input::get('name');
        $seat->extra_price = Input::get('extra_price');

        if(Input::file('image'))  $seat->image = str_replace("public/","",$path);
        $seat->save();

        if(env('EMBROIDERY_CAR_MODEL_ID')==$seat->car_model_id) {
            $seat->price_ranges()->sync($request->price_range);
        }


        // redirect
        // Session::flash('message', 'Successfully updated nerd!');
        return back()->with('status', 'Seat Modified!');
    }
    public function destroy($id)
    {
        // delete
        $seat = Seat::find($id);
        $car_model_seats = CarModelSeat::where('seat_id', '=', $id)->get();
        foreach ($car_model_seats as $car_model_seat)
        {
            $car_model_seat->delete();
        }
     $seat->delete();
   // redirect
        return back()->with('status', 'Seat deleted!');
    }

    public function deleteSeat(Request $request, $id)
    {
        $car_model_seat = CarModelSeat::where('seat_id', '=', $id)->where('car_model_id', '=', $request->car_model_id)->first();
        $car_model_seat->delete();

        // redirect
        return back()->with('status', 'Assigned Seat deleted!');
    }
}

Car_Seat_Cover_Configurator-Laravel/resources/views/pages/seats/home-no-tabs.blade.php
@extends('layouts.app')

@section('content')

<div class="container-fluid">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <a href="{{url('home')}}">Home </a> >
                    <a href="{{route('manufacturers.index')}}">
                        Manufacturers
                    </a>>
                    <a href="{{route('manufacturers.cars.index',$car_model->car->manufacturer->getId())}}">
                        {{$car_model->car->manufacturer->getName()}}
                    </a>>
                    <a href="{{route('cars.models.index',$car_model->car->getId())}}">
                        {{$car_model->car->getName()}}
                    </a>>
                    @if(auth()->user()->hasRole('yaco_data_manager'))
                    <a href="{{route('models.seats.index',$car_model->getId())}}">
                        {{$car_model->getName()}} Seats
                    </a>
                    @endif
                    @if(auth()->user()->hasRole('wellfit_data_manager'))
                        <a href="{{route('models.layouts.index',$car_model->getId())}}">
                            {{$car_model->getName()}} Layouts
                        </a>
                    @endif
                    <div class="dash-heading">@if(auth()->user()->hasRole('yaco_data_manager'))SEAT DESIGNS @endif  @if(auth()->user()->hasRole('wellfit_data_manager'))LAYOUTS @endif</div>
                    
                </div>

                <div class="panel-body">
                        <div class="tab-content">
                        @yield('sub-content')
                        </div>
                </div>
            </div>
        </div>
    </div>
</div>                    
@endsection

Car_Seat_Cover_Configurator-Laravel/resources/views/pages/seats/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <a href="{{url('home')}}">Home </a> >
                    <a href="{{route('manufacturers.index')}}">
                        Manufacturers
                    </a>>
                    <a href="{{route('manufacturers.cars.index',$car_model->car->manufacturer->getId())}}">
                        {{$car_model->car->manufacturer->getName()}}
                    </a>>
                    <a href="{{route('cars.models.index',$car_model->car->getId())}}">
                        {{$car_model->car->getName()}}
                    </a>>
                    @if(auth()->user()->hasRole('yaco_data_manager'))
                        <a href="{{route('models.seats.index',$car_model->getId())}}">
                            {{$car_model->getName()}} Seats
                        </a>
                    @endif
                    @if(auth()->user()->hasRole('wellfit_data_manager'))
                        <a href="{{route('models.layouts.index',$car_model->getId())}}">
                            {{$car_model->getName()}} Layouts
                        </a>
                    @endif
                    <div class="dash-heading"> @if(auth()->user()->hasRole('yaco_data_manager'))SEAT DESIGNS @endif  @if(auth()->user()->hasRole('wellfit_data_manager'))LAYOUTS @endif </div>
                    
                </div>

                <div class="panel-body">
                        <ul class="nav nav-tabs">
                            @if(auth()->user()->hasRole('yaco_data_manager'))
                          <li class="@if($tab=='models')active @endif">
                            <a href="{{route('models.seats.index',$car_model->getId())}}">Seat Designs</a>
                          </li>
                          <li class="@if($tab=='add-model')active @endif">
                            <a href="{{route('models.seats.create',$car_model->getId())}}">+ Add Seat Design</a>
                          </li>
                            @endif
                                @if(auth()->user()->hasRole('wellfit_data_manager'))
                          <li class="@if($tab=='layouts')active @endif pull-right">
                            <a href="{{route('models.layouts.index',$car_model->getId())}}">Layouts</a>
                           </li>
                           <li class="@if($tab=='add-layout')active @endif pull-right">
                            <a href="{{route('models.layouts.create',$car_model->getId())}}">+ Add Layout</a>
                          </li>
                                    @endif
                        </ul>

                        <div class="tab-content">
                        @yield('sub-content')
                        </div>
                </div>
            </div>
        </div>
    </div>
</div>                    
@endsection